// Script: DDOBJ (Drag-and-Drop DHTML Objects) v1.2
// Company: Interaxis
// Author: dynamicreport.com
// Website: http://dynamicreport.com/ddobj.html
// License: This script is subject to the EULA included in the DDOBJ package



var sRelPath = "images/"; // transparent image relative path excluding 'trans.gif' filename but including last forward slash
// (i.e. relative path from page folder containing inclusion to this javascript file) (eg. images/ or "" if in same folder)

var ddobj = ddobj_ = ddcover = ddimg = ddc = null; // objects -- when not null, they are tracked by document's move event
var dd_x = dd_y = dd_bForced = 0; // track coordinates for locking on a layer drag operation, force layer drag flag
var dd_ox = dd_oy = 0; // top/left corner of the page
var dd_lock = 0; // toggle the drag-and-drop operation of an object so that obscure interruptions amongst various objects are avoided
var DD_OFFSETX = -15; // X offset from cursor to start of drag-drop layer
var DD_OFFSETY = -15; // Y offset from cursor to start of drag-drop layer
var DD_DRAGY = 25; // 25 pixels of vertical space will activate the drag-drop operation if dd_bDragAll is not set (0)
var DD_MAXOBJS = 25; // to be safe from an infinite loop situation, set the max # of drag-drop objects on a page
var dd_bInit = 0; // this script has not been initialized yet by a call to dd_initLyr ()
var dd_bDragAll = 1; // internal flag marks whether the entire object is draggable (1) or just a portion (0)
var dd_close = 1; // enable object close section
var DD_CLOSEX = -5; // offset close icon 5 pixels left from top-right corner of drag-drop layer
var DD_CLOSEY = 5; // offset close icon 5 pixels down from top-right corner of drag-drop layer
var DD_WAITSHOWHIDE = -1; // this flag will be reset and showlyr will exit so that the function call is disabled 
// once (necessary to ignore an event handler for an object temporarily 

// INITIALIZE BROWSER DETECTION AND BROWSER-SPECIFIC DOM OBJECT VALUES
var dd_ns = dd_ie = dd_opera = dd_features = 0;
var set_show = set_hide = "";

// SKIN TEMPLATE -- CAPTION & CONTENT IS ENCOMPASSED BY THE HEADER AND FOOTER
var dd_sHeaderT = "";
var dd_sHeaderB = "";
var dd_sFooter = "";

function dd_getUnitValue (sVal)
{
	var sTotal = "";
	iMul = 1;
	for (i = 0; i < sVal.length; i++)
	{
		if (sVal.charAt (0) == '-')
			iMul = -1;
		if (sVal.charAt (i) >= '0' && sVal.charAt (i) <= '9')
			sTotal += sVal.charAt (i);
	}
	return iMul * parseInt (sTotal);
}


function dd_setBrowser ()
{
	var agt = navigator.userAgent.toLowerCase ();
  
	// determine browser types and versions
	if (agt.indexOf("opera") != -1)
		dd_opera = parseInt (navigator.appVersion);

	if (navigator.appName == "Microsoft Internet Explorer")
		dd_ie = parseInt (navigator.appVersion);
	else if (navigator.appName == "Netscape")
		dd_ns = parseInt (navigator.appVersion);

	// browser-specific visibility flags
	set_show = (dd_ns) ? 'show' : 'visible';
	set_hide = (dd_ns) ? 'hide' : 'hidden';

	if (dd_ns >= 5)
	{
		set_show = 'visible';
		set_hide = 'hidden';
	}

	// determine applicable features
	if (dd_ie >= 4 || dd_ns >= 5)
		dd_features = 1;
	else if (dd_ns >= 4)
		dd_features = 2;
	else
		dd_features = 0;
}



function dd_updLyr (iIndex, activeUpdate)
{
	sExt = "dd" + iIndex;

	if (dd_features == 1)
	{
		if (activeUpdate)
		{
			document.getElementById(sExt).style.width = document.getElementById("dd_w"+iIndex).style.width;
			document.getElementById(sExt).style.height = dd_bDragAll ? document.getElementById("flt_"+sExt).offsetHeight : DD_DRAGY;
			document.getElementById("flt_" + sExt).style.width = document.getElementById("dd_w"+iIndex).style.width;
			document.getElementById("ovr_" + sExt).style.width = document.getElementById("dd_w"+iIndex).style.width;
			document.getElementById("ovr_" + sExt).style.height = dd_bDragAll ? document.getElementById("flt_"+sExt).offsetHeight : DD_DRAGY;
		}
		else
		{
			document.getElementById("flt_" + sExt).style.visibility = set_hide;
			document.getElementById("ovr_" + sExt).style.visibility = set_hide;
		}
		if (dd_ie)
		{
			if (activeUpdate)
			{
				document.getElementById("cvr_" + sExt).style.width = document.getElementById("dd_w"+iIndex).style.width;
				document.getElementById("cvr_" + sExt).style.height = document.getElementById("flt_"+sExt).offsetHeight;
			}
			else
			{
				document.getElementById("cvr_" + sExt).style.visibility = set_hide;
				document.getElementById(sExt).style.visibility = set_hide;
			}
			// iframe hack for drop-down to appear below layer
			if (dd_ie && !dd_opera)
				document.getElementById("cvr_" + sExt).style.display = "inline";
			document.getElementById("cvr_" + sExt).style.left = document.getElementById("flt_" + sExt).style.left;
			document.getElementById("cvr_" + sExt).style.top = document.getElementById("flt_" + sExt).style.top;
		}
	}
	else if (dd_features == 2)
	{
		if (document.layers["flt_" + sExt])
		{
			if (activeUpdate)
			{
				document.layers["ovr_" + sExt].left = document.layers["flt_" + sExt].left;
				document.layers["ovr_" + sExt].top = document.layers["flt_" + sExt].top;
				document.layers["ovr_" + sExt].document.open();
				document.layers["ovr_" + sExt].document.write("<img src='"+sRelPath+"trans.gif' id = '"+sExt+"' name='"+sExt+"' border = '0' width='" + document.layers["flt_" + sExt].clip.right + "' height='" + (dd_bDragAll ? document.layers["flt_" + sExt].clip.bottom : DD_DRAGY) + "'>");
				document.layers["ovr_" + sExt].document.close();
			}
			else
			{
				document.layers["flt_" + sExt].visibility = set_hide;
				document.layers["ovr_" + sExt].visibility = set_hide;
			}
		}
	}
}


function dd_initLyr()
{
	if (dd_features == 1)
	{
		// track W3C DOM standard events
		document.onmousedown = dd_down;
		document.onmouseup = dd_up;
		document.onmousemove = dd_move;
		for (iIndex = 0; iIndex < DD_MAXOBJS && document.getElementById("ovr_dd" + iIndex); iIndex++)
			dd_updLyr (iIndex, 0);
	}
	else if (dd_features == 2)
	{
		// track DOM events with Netscape 4.x
		window.captureEvents(Event.MOUSEDOWN | Event.MOUSEUP | Event.MOUSEMOVE);
		window.onmousedown = dd_down;
		window.onmouseup = dd_up;
		window.onmousemove = dd_move;
		for (iIndex = 0; iIndex < DD_MAXOBJS && document.layers["ovr_dd" + iIndex]; iIndex++)
			dd_updLyr (iIndex, 0);
	}
	dd_bInit = 1; // ok to begin tracking the objects -- avoid premature interruption of initialization
}


function dd_down(e) // called once only when the mouse button is clicked initially
{
	dd_bForced = 0;

	if (dd_features == 1)
	{
		if (dd_ns)
		{
			if (!e)
				return true;
			dd_ox = e.pageX; // obtain cursor location
			dd_oy = e.pageY;
			if ((!e.target || !e.target.name) && dd_bDragAll) // verify that the object is valid and it is a ddobj
				return false;
			if ((!e.target || !e.target.name) && !dd_bDragAll)
				return true; // true enables default mousedown event handling
			if ((e.target.name[0] != 'd' && e.target.name[1] != 'd'))
				return true;

			// object exists, set all object references
			ddimg = document[e.target.name];
			ddobj_ = document.getElementById("flt_" + e.target.name);
			ddobj = document.getElementById("ovr_" + e.target.name);
			ddc = document.getElementById("c_" + e.target.name);

			if (!dd_lock) // bring the selected layer to the front
			{
				ddobj_.style.zIndex = dd_zIndex;
				ddobj.style.zIndex = dd_zIndex + 1;
				ddc.style.zIndex = dd_zIndex + 1;
				dd_zIndex += 2;
			}

			dd_lock = 1; // once it is identified as a dd object, flag the lock down

			ddc = document.getElementById("c_" + e.target.name);
			dd_x = e.pageX - dd_getUnitValue (ddobj.style.left); // calculate cursor position relative to layer
			dd_y = e.pageY - dd_getUnitValue (ddobj.style.top);
			if (e.target.name[0] == 'd' && e.target.name[1] == 'd')
				return false;
		}
		else
		{
			if (!window.event) // verify that the object is valid and it is a ddobj
				return false;  // false enables default mousedown event handling
			if (window.event.srcElement.id.charAt (0) != 'd' && window.event.srcElement.id.charAt (1) != 'd')
				return true;

			ddimg = window.event.srcElement.parentElement; // set all object references
			ddobj = document.getElementById("ovr_" + window.event.srcElement.id);
			ddobj_ = document.getElementById("flt_" + window.event.srcElement.id);
			ddc = document.getElementById("c_" + window.event.srcElement.id);

			if (!dd_lock) // bring the selected layer to the front
			{
				ddobj_.style.zIndex = dd_zIndex;
				ddobj.style.zIndex = dd_zIndex + 1;
				ddc.style.zIndex = dd_zIndex + 1;
				dd_zIndex += 2;
			}

			dd_lock = 1; // once it is identified as a dd object, flag the lock down

			if (dd_ie)
				ddcover = document.getElementById("cvr_" + window.event.srcElement.id);
			dd_x = window.event.offsetX; // obtain cursor location
			dd_y = window.event.offsetY;

			if (window.event.srcElement != ddobj)
				return false;
		}
	}
	else if (dd_features == 2)
	{
		if (!e)
			return true;
		dd_ox = e.pageX; // obtain cursor location
		dd_oy = e.pageY;
		if (!e.target || !e.target.name) // verify that the object is valid and it is a ddobj
			return true;
		if ((e.target.name[0] != 'd' && e.target.name[1] != 'd'))
			return true;
		if (document.layers["ovr_" + e.target.name]) // object exists, set all object references
		{
			ddimg = document[e.target.name];
			ddobj_ = document.layers["flt_" + e.target.name];
			ddobj = document.layers["ovr_" + e.target.name];
			ddc = document.layers["c_" + e.target.name];

			if (!dd_lock) // bring the selected layer to the front
			{
				ddobj_.zIndex = dd_zIndex;
				ddobj.zIndex = dd_zIndex + 1;
				ddc.zIndex = dd_zIndex + 1;
				dd_zIndex += 2;
			}

			dd_lock = 1; // once it is identified as a dd object, flag the lock down

			dd_x = e.pageX - ddobj.left; // calculate cursor position relative to layer
			dd_y = e.pageY - ddobj.top;
			return false;
		}
		return true;
	}
	return true;
}


function dd_forceMove(iIndex)
{
	sExt = "dd" + iIndex;
	if (dd_features == 1)
	{
		ddobj = document.getElementById("ovr_" + sExt); // set all object references
		ddobj_ = document.getElementById("flt_" + sExt);
		ddimg = document.getElementById(sExt);
		ddc = document.getElementById("c_" + sExt);
		if (dd_ie) // iframe hack for IE
			ddcover = document.getElementById("cvr_" + sExt);
		if (dd_ns)
			dd_offset (dd_ox - DD_OFFSETX, dd_oy - DD_OFFSETY); // move action associated with object tracking cursor -- set offset from cursor position (dd_ox/dd_oy already assigned by move or down event handlers)
	}
	else if (dd_features == 2)
	{
		if (document.layers["ovr_" + sExt]) // object exists, set all object references
		{
			ddobj = document.layers["ovr_" + sExt];
			ddobj_ = document.layers["flt_" + sExt];
			ddc = document.layers["c_" + sExt];
			dd_offset (dd_ox - DD_OFFSETX, dd_oy - DD_OFFSETY); // move action associated with object tracking cursor -- set offset from cursor position (dd_ox/dd_oy already assigned by move or down event handlers)
		}
		else
			return true;
	}
}


function dd_offset (offsetX, offsetY)
{
	if (dd_features == 1 && ddobj)
	{
		if (dd_ns)
		{
			ddobj.style.left = ddobj_.style.left = offsetX;
			ddobj.style.top = ddobj_.style.top = offsetY;
			ddc.style.top = offsetY + DD_CLOSEY;
			ddc.style.left = dd_getUnitValue (ddobj.style.left) + dd_getUnitValue (ddobj_.style.width) - dd_getUnitValue (ddc.style.width) + DD_CLOSEX;
		}
		else
		{
			ddobj.style.posLeft = ddobj_.style.posLeft = offsetX;
			ddobj.style.posTop = ddobj_.style.posTop = offsetY;
			ddc.style.posTop = offsetY + DD_CLOSEY;
			ddc.style.posLeft = ddobj.style.posLeft + dd_getUnitValue (ddobj_.style.width) - dd_getUnitValue (ddc.style.width) + DD_CLOSEX;
			if (dd_ie)
			{
				ddcover.style.posLeft = offsetX;
				ddcover.style.posTop = offsetY;
			}
		}
	}
	else if (dd_features == 2 && ddobj)
	{
		ddobj.left = ddobj_.left = offsetX;
		ddobj.top = ddobj_.top = ddc.top = offsetY;
		ddc.top += DD_CLOSEY;
		ddc.left = ddobj.left + ddobj_.clip.right - ddc.clip.right + DD_CLOSEX;
	}
}


// called continuously for the duration of the object mouse move event
function dd_move(e) // MSIE does not receive an event object parameter (only Mozilla browsers -- NN, Firefox, etc.)
{
	if (dd_bForced) // move action associated with object tracking cursor -- set offset from cursor position
	{
		dd_x = DD_OFFSETX;
		dd_y = DD_OFFSETY;
	}

	if (dd_ns) // obtain cursor location
	{
		dd_ox = e.pageX;
		dd_oy = e.pageY;
	}

	if (dd_features == 1 && ddobj)
	{
		if (dd_ns)
			dd_offset (e.pageX - dd_x, e.pageY - dd_y);
		else
			dd_offset (document.body.scrollLeft + window.event.clientX - dd_x, document.body.scrollTop + window.event.clientY - dd_y);
		ddobj.style.visibility = set_show;
		ddobj_.style.visibility = set_show;
		ddimg.style.visibility = set_show;
		if (dd_close)
			ddc.style.visibility = set_show;
		if (dd_ie)
			ddcover.style.visibility = set_show;
		return false;
	}
	else if (dd_features == 2 && ddobj)
	{
		dd_offset (e.pageX - dd_x, e.pageY - dd_y);
		ddobj.visibility = set_show;
		ddobj_.visibility = set_show;
		if (dd_close)
			ddc.visibility = set_show;
	}
	return true;
}


function dd_up()
{
	// clear current objects since they're not being tracked for motion (drag-drop operation non-existent)
	ddobj = ddobj_ = ddimg = ddcover = ddc = null;
	dd_lock = 0;
	return true;
}


function dd_release()
{
	// clear current objects since they're not being tracked for motion (drag-drop operation non-existent)
	// user-call version of the dd_up function to release the object drag operation safely without obscure interruption
	// of the drag operation of another object
	if (!dd_lock)
	{

		ddobj = ddobj_ = ddimg = ddcover = ddc = null;
		dd_bForced = 0;
	}
	return true;
}


function dd_showLyr(iIndex, bSwitch, bDragAll, sTitle, sContent, w)
{
	if (!dd_bInit) // not yet initialized
		return false;
		
	if (dd_lock)
		return true;

	if (DD_WAITSHOWHIDE == iIndex)
	{
		DD_WAITSHOWHIDE = -1;
		return false;
	}

	sExt = "dd" + iIndex;

	if (bSwitch) // hide object before making it visible again (avoid glitch appearance when reused object is redrawn during transitional change)
		dd_setvis (iIndex, set_hide);

	dd_bForced = 0;

	if (bSwitch) // set actual toggle visibility parameter to visible or invisible
		sVis = set_show;
	else
		sVis = set_hide;

	dd_bDragAll = bDragAll; // global reminder that the current object is to be completely or partially draggable

	if (bSwitch) // visible, initializing the drag-drop layer
	{
		// modify the HTML tags that define the DDOBJ layout template
		if (sContent != "")
		{
			sCaption = "<table id = 'dd_w"+iIndex+"' width = '"+w+"' cellpadding = '0' cellspacing = '0' border = '0'";
			if (dd_features == 1)
				sCaption += " style = 'width:"+w+";'";
			sCaption += "><tr><td valign = 'top' align = 'left'>";
			sCaption += dd_sHeaderT;
			sCaption += sTitle;
			sCaption += dd_sHeaderB;
			sCaption += sContent;
			sCaption += dd_sFooter;
			sCaption += "</td></tr></table>";
	
			if (dd_features == 1)
				document.getElementById("flt_" + sExt).innerHTML = sCaption;
			else if (dd_features == 2 && bSwitch) // visible, initializing the drag-drop layer
			{
				document.layers["flt_" + sExt].document.open ();
				document.layers["flt_" + sExt].document.write (sCaption);
				document.layers["flt_" + sExt].document.close ();
			}
		}
		dd_updLyr (iIndex, 1);
		dd_forceMove (iIndex);
		dd_bForced = 1;
		if (dd_ie) // force initial move
			dd_move (0);
	}

	if (!bSwitch) // end move event tracking
		dd_up ();
	// visibility is accomplished after the update (to hide glitch effect of visible update)
	dd_setvis (iIndex, sVis);
}


function dd_setvis (iIndex, sVis)
{
	sExt = "dd" + iIndex;

	// toggle visibility of all components belonging to a single object by index
	if (dd_features == 1)
	{
		document.getElementById("ovr_" + sExt).style.visibility = sVis;
		document.getElementById("flt_" + sExt).style.visibility = sVis;
		document.getElementById(sExt).style.visibility = sVis;
		if (dd_close)
			document.getElementById("c_" + sExt).style.visibility = sVis;
		if (dd_ie && !dd_opera)
			document.getElementById("cvr_" + sExt).style.visibility = sVis;
	}
	else if (dd_features == 2)
	{
		document.layers["ovr_" + sExt].visibility = sVis;
		document.layers["flt_" + sExt].visibility = sVis;
		if (dd_close)
			document.layers["c_" + sExt].visibility = sVis;
	}
}


// ------------------------------------- SKIN SELECTOR FUNCTIONS (DEFINE YOUR OWN SKINS HERE)

function dd_skin_tab (w)
{
	dd_sHeaderT = "" +
	"<table width = '"+w+"' border = '0' cellspacing = '0' cellpadding = '0'>" +
 	" <tr>" +
	"  <td width = '10'><img src = '"+sRelPath+"skins/tab/con-l1.gif'></td>" +
	"  <td width = '175' background = '"+sRelPath+"skins/tab/con-c1.gif' valign = 'top'><img src = '"+sRelPath+"skins/tab/con-c1.gif'></td>" +
	"  <td width = '20' align = 'left' background = '"+sRelPath+"skins/tab/con-r10bg.jpg'><img src = '"+sRelPath+"skins/tab/con-r10.gif'></td>" +
	"  <td width = '999' background = '"+sRelPath+"skins/tab/con-r10bg.jpg' align = 'left'><img src = '"+sRelPath+"skins/tab/con-r10bg.jpg'></td>" +
	"  <td width = '8'><img src = '"+sRelPath+"skins/tab/con-r11.gif'></td>" +
	" </tr>" +
	" <tr>" +
	"  <td width = '10' background = '"+sRelPath+"skins/tab/con-l2.gif' valign = 'top'><img src = '"+sRelPath+"skins/tab/con-l2.gif'></td>" +
	"  <td width = '175' background = '"+sRelPath+"skins/tab/bg.jpg'>";

	// header text parameter would appear here

	dd_sHeaderB = "" + 
	"  </td>" +
	"  <td width = '20' background = '"+sRelPath+"skins/tab/con-r20_bg.jpg' align = 'left' valign = 'top'><img src = '"+sRelPath+"skins/tab/con-r20.jpg'></td>" +
	"  <td width = '367' background = '"+sRelPath+"skins/tab/con-r20_bg1.jpg' align = 'left' valign = 'top'><img src = '"+sRelPath+"skins/tab/con-r20bg.jpg'></td>" +
	"  <td width = '8' background = '"+sRelPath+"skins/tab/con-r21_bg.jpg' valign = 'top'><img src = '"+sRelPath+"skins/tab/con-r21.jpg'></td>" +
	" </tr>" +
	" <tr>" +
	"  <td width = '10'><img src = '"+sRelPath+"skins/tab/con-l3.gif'></td>" +
	"  <td width = '175' background = '"+sRelPath+"skins/tab/con-c3.jpg'><img src = '"+sRelPath+"skins/tab/con-c3.jpg'></td>" +
	"  <td width = '20' align = 'left' background = '"+sRelPath+"skins/tab/con-r30bg.jpg'><img src = '"+sRelPath+"skins/tab/con-r30.jpg'></td>" +
	"  <td width = '367' background = '"+sRelPath+"skins/tab/con-r30bg.jpg' align = 'left' valign = 'top'><img src = '"+sRelPath+"skins/tab/con-r30bg.jpg'></td>" +
	"  <td width = '8'><img src = '"+sRelPath+"skins/tab/con-r31.jpg'></td>" +
	" </tr>" +
	" <tr>" +
	"  <td width = '10' background = '"+sRelPath+"skins/tab/con-l4.jpg'><img src = '"+sRelPath+"skins/tab/con-l4.jpg'></td>" +
	"  <td width = '*' valign = 'top' background = '"+sRelPath+"skins/tab/bg.jpg' colspan = '3'>";

	// main window text parameter would appear here

	dd_sFooter = "<p class = 'css_style3' alt = 'Get DDOBJ!' align = 'right'>DDOBJ - dynamicreport.com</p>" +
	"  </td>" +
	"  <td width = '8' background = '"+sRelPath+"skins/tab/con-r4.jpg'><img src = '"+sRelPath+"skins/tab/con-r4.jpg'></td>" +
	" </tr>" +
	" <tr>" +
	"  <td width = '10'><img src = '"+sRelPath+"skins/tab/con-l5.gif'></td>" +
	"  <td width = '345' background = '"+sRelPath+"skins/tab/con-c5.jpg' colspan = '3'><img src = '"+sRelPath+"skins/tab/con-c5.jpg'></td>" +
	"  <td width = '8'><img src = '"+sRelPath+"skins/tab/con-r5.gif'></td>" +
	" </tr>" +
	"</table>";

	DD_DRAGY = 30;
	DD_CLOSEX = -5;
	DD_CLOSEY = 5;
}


function dd_skin_default ()
{
	dd_sHeaderT = "<table width = '100%' cellpadding = '0' cellspacing = '0' border = '1'>" +
	"<tr><td bgcolor = '#DFDFEE' height = '20' valign = 'top'>";

	// header text parameter would appear here

	dd_sHeaderB = "</td></tr>" +
	"<tr><td bgcolor = '#EDEDED' valign = 'top'>";

	// main window text parameter would appear here
	
	dd_sFooter = "<p class = 'css_style3' alt = 'Get DDOBJ!' align = 'right'>DDOBJ - dynamicreport.com</p>" +
	"</td></tr></table>";

	DD_DRAGY = 25;
	DD_CLOSEX = -1;
	DD_CLOSEY = 2;
}
